--[[
ToDo:
When not resting and on a mount, check and then remind the user to apply tracking if they have the ability to do so in a timeframe with scrolling text and a sound
Tracking: Hunter tracking abilites, clouds (eng), ore (mining),
Add zone check support (default off in BGs), allow user to add custom zones
Allow the sound name to be changed, or find a sound to use with it
Custom triggers (if not IsResting() and ( IsMounted() or (UnitLevel'player' < 30)) and not UnitAffectingCombat('player') then)
Support for travel forms (stance) --shaman: if GetShapeshiftForm(true) == 1 --druid: if GetShapeshiftForm(true) == 2 or 3 or 4 or 6
--CancelTrackingBuff()
Auto-change tracking support (on mouse-wheel?)
Add a check for professions
Make vars local
Allow TR_trackWant to be a table of diffrent trackings that the user wants, IE: Find Minerals, Find Herbs, and to only notify the user when one of those trackings are not on
Key bindings for diffrent trackings, rename 'TrackingHelper' 'TrackingHand'?
]]


local fnd = _G.string.find
local lower = _G.string.lower
local sub = _G.string.sub
local rep = _G.strreplace

local addon = CreateFrame("Frame")

local function pr(msg)
	ChatFrame1:AddMessage(msg,.1,.7,.7)
end

local currentTrack, canCheckTracking, activeTrack, trackingNames
TR_SV = {}
TR_SV["toggle"] = true
local timeCache = {}
timeCache["lastupdate"] = 0
TR_SV["frequency"] = 30
TR_SV["dbreversion"] = 1
TR_trackWant = ""

--Check in seconds of TR_SV["frequency"] and display our notifications if needed
addon:SetScript("OnUpdate", function (self, _)
	if ( timeCache["lastupdate"] + TR_SV["frequency"] ) < GetTime() then
		if TR_SV["toggle"] and TR_trackWant and not ( TR_trackWant == "None") and not ( TR_trackWant == "")then
			if canCheckTracking() then
				--ChatFrame1:AddMessage("trigger1")
				if not ( activeTrack() == TR_trackWant ) then
					if ( MikSBT and ( not ( MikSBT.IsModDisabled() ) ) ) then
						MikSBT.DisplayMessage("Your "..TR_trackWant.." is not active.")
					else
						UIErrorsFrame:AddMessage("Your "..TR_trackWant.." is not active.")
					end
					--ChatFrame1:AddMessage("Your "..trackWant.." is not active.")
					PlaySound'ReadyCheck'
				end
			end
		end
		timeCache["lastupdate"] = GetTime()
	end	
end)

function addon:ADDON_LOADED(name)
	if name == "TrackingReminder" then
		if TR_trackWant == "" then
			pr'You have not defined what track type you want to be reminded of on this character, please key "/tr track NAME" where NAME is what you wish to track.'			
		end
	end
end

--Returns true if we should check the tracking
function canCheckTracking()
	if not IsResting() and not UnitAffectingCombat('player') then	
		if ( IsMounted() or (UnitLevel'player' < 30) ) then
			return true
		elseif select(2,UnitClass'player') == 'DRUID' then
			local shape = GetShapeshiftForm(true)
			if shape == 2 or shape == 3 or shape == 4 or shape == 6 then
				return true
			else
				return false
			end
		elseif select(2,UnitClass'player') == 'SHAMAN' then
			if GetShapeshiftForm(true) == 1 then
				return true
			else
				return false
			end
		else
			return false
		end
	else
		return false
	end
end

--Returns the name of the current active track
function activeTrack()
	for i=1, GetNumTrackingTypes() do
		local name, texture, active, category = GetTrackingInfo(i)
		if active then
			return lower(name)
		end
		--[[ChatFrame1:AddMessage(i)		
		ChatFrame1:AddMessage(name or "nil")
		ChatFrame1:AddMessage(texture or "nil")
		ChatFrame1:AddMessage(active or "nil")
		ChatFrame1:AddMessage(category or "nil")
		ChatFrame1:AddMessage("\n")]]
	end
end

--Returns the name of avaible tracking in table and string for addon and chat use
function trackingNames()
	local t = {}
	local s 
	for i=1, GetNumTrackingTypes() do
		local name, texture, active, category = GetTrackingInfo(i)
		t[lower(name)] = lower(name)
		if not s then
			s = name		
		else
			s = s..", "..name
		end
	end
	return t, s
end

--toggle, on, off, set, available, frequency, current, up
SLASH_TRACKINGREMINDER1 = "/trackr"
SLASH_TRACKINGREMINDER2 = "/tr"
SLASH_TRACKINGREMINDER3 = "/trackingreminder"
SlashCmdList["TRACKINGREMINDER"] = function( msg )
	local i,j, cmd1, cmd2 = string.find(msg, "^([^ ]+) ?(.*)$")
	--pr("cmd1 "..(cmd1 or "nocmd1"))
	--pr("cmd2 "..(cmd2 or "nocmd2"))
	local tog = ""
	if TR_SV["toggle"] then
		tog = "Currently on"
	else
		tog = "Currently off"
	end
	pr('TrackingReminder: '..tog.." '"..(TR_trackWant or "Nothing").."' with a frequency of '"..TR_SV["frequency"].."' seconds.")
	cmd1 = lower(cmd1 or "")
	local trackNameTable, trackNameString = trackingNames()
	if cmd1 == "" or not cmd1 then
		pr"Accepted commands are: toggle, on, off, set, available, frequency, current, up, use, help.\nKey \"/tr help\" for usage information"
	elseif cmd1 == "toggle" then
		pr'Toggle'
		if TR_SV["toggle"] then
			pr'Off'
			TR_SV["toggle"] = false
		else
			pr'On'
			TR_SV["toggle"] = true
		end
	elseif cmd1 == 'on' then
		pr'On'
		TR_SV["toggle"] = true
	elseif cmd1 == 'off' then
		pr'Off'
		TR_SV["toggle"] = false
	elseif cmd1 == 'set' then
		--pr'set'
		if cmd2 == nil then
			pr'Tracking type has been set to Nothing.'
			TR_trackWant = nil
		elseif cmd2 == "" then
			pr'Tracking type has been set to Nothing.'
			TR_trackWant = nil
		else
			--local counter
			--if fnd(cmd2,",") then
				--Put code here for allowing mutiple track types
			--else
				if trackNameTable[lower(cmd2)] == lower(cmd2) then
					pr('Tracking type has been set to '..cmd2..'.')
					TR_trackWant = lower(cmd2)
					return
				end
				
			--end
--			if trackNameTable[lower(cmd2)] == lower(cmd2) then
			--if trackNameTable[lower(cmd2)] == lower(cmd2) then
--			if trackNameTable["find herbs"] == lower("find herbs, find minerals") then
				--pr('Tracking type has been set to '..cmd2..'.')
				--TR_trackWant = lower(cmd2)
				--return
			--end
			--Add check to see if the current player has the tracking type
			pr('This character does not have the tracking type '..cmd2..'.')
			TR_trackWant = nil
		end
	elseif cmd1 == 'use' or cmd1 == 'help' then
		pr'TrackingReminder is a simplistic mod that is designed to remind you to make the wanted tracking active, if you happen to disable it. For example, have you ever flown around for 15 minutes looking for herbs, pondering where all the herbs disipeared to, and then noticed you had your repair tracking active?.'
		pr'The mod reminds you through a scrolling frame (MikScrollingBattleText or the default UI, it is recremended to use MikSBT, as it is more dynamic). Also, you will be reminded with the sound of raid warning.'
		pr'To set the wanted tracking type, key "/tr set NAME" where NAME is a track type. This track type needs to be the exact name of the tracking, like "Find Herbs" or "Find Minerals". To see the track methods available to the current character, key "/tr available".'
		pr'To set the time between notifictions, key "/tr frequency NUMBER" where NUMBER is a number, in seconds, defaulted to 30.'
		pr'The mod will only notifiy you of your tracking when you are not resting or in combat; either mounted, using a druid/shaman traveling ability, or are below level 30.'
		pr'You may toggle the mod by keying "/tr {toggle | on | off}" IE: /tr on.'
		--pr'use or help'
		--cmd2 = lower(cmd2)
		--[[
		if not cmd2 or cmd2 == "" then
			pr'InstanceMinion is an auto-reply mod when one of these patterns are whispred to you: "spec", "specialization", "instance", "heal", "dps", "raid", "group", "party", "lfg", "queue", "tank", "resto", "quest", or "lf.?m".'
			pr'To enable/disable these filters, delete or add the line that contains the filter you want, of if you are not savvy, post a request in the comments of where you downloaded this mod.'
			pr(string.format ('%q','Accepted commands: /{im|instanceminion} {help| toggle|on|off|set|use|current|up|update|whisper}'))
			pr(string.format ('%q','Key /im help {help| toggle|on|off|set|use|current|up|update|whisper} for more information about a command.'))
		elseif cmd2 == "help" then
			pr'/im help'
			pr'Display the help message.'
		elseif cmd2 == "toggle" then
			pr'/im toggle'
			pr'Toggles the auto-response on if it is off, or off if it is on.'
		elseif cmd2 == "on" then
			pr'/im on'
			pr'Toggles the auto-response on.'			
		elseif cmd2 == "off" then
			pr'/im off'
			pr'Toggles the auto-response off.'
		elseif cmd2 == "set" then
			pr'/im set'
			pr('Sets the message to be appended as the sufix after the talent distribution when invoked in an auto-reply. Currently is '..#TR_SVIM_SUFIX	..' characters long a set to: '..TR_SVIM_SUFIX)
		elseif cmd2 == "use" then
			pr'/im use'
			pr'Display the help message'
		elseif cmd2 == "current" then
			pr'/im current'
			local currentStr = getSpec() .. TR_SVIM_SUFIX
			strLen = #currentStr
			pr("Your current auto responce message is currently  set to \n\n"..currentStr.."\n\nThis message is "..strLen.." characters long.")
		elseif cmd2 == "whisper" then
			pr'/im whisper Someone'
			pr("Attempts to whisper Someone your auto-responce.")
		else
			pr'Your help query was not found.'
		end]]
	elseif cmd1 == 'available' then
		pr("The current available tracking types to this character are: "..trackNameString..".\nKey \"/tr set NAME\" to set NAME to the current tracking.")
	elseif cmd1 == 'current' then
		--pr'current'
		--local currentStr = getSpec() .. TR_SVIM_SUFIX
		--strLen = #currentStr
		pr("Your current tracking type is "..(TR_trackWant or "Nothing")..". With a frequency of "..TR_SV["frequency"].." seconds.")
	elseif cmd1 == 'frequency' then
		if fnd(cmd2,"^(%d+)$") then
			pr('Will check for tracking every '..cmd2..' seconds when mounted (or druid or shaman forms), not resting, and not in combat.')
			TR_SV["frequency"] = cmd2
		else
			pr('Tracking frequency must be a number, in seconds.\nCurrently set to '..TR_SV["frequency"].." seconds.")
		end
	elseif cmd1 == "up" or cmd1 == "update" then
		pr'Updates are at WoWInterface.com under "TrackingReminder"'
	--[[elseif cmd1 == "whisper" then
		if cmd2 == "" or not cmd2 then
			pr'No whisper target specified.'
		else
			local msgToSend = getSpec() .. TR_SVIM_SUFIX 
			if ChatThrottleLib then
				--pr'ctl'
				ChatThrottleLib:SendChatMessage("NORMAL", "InstanceMinion", sub(msgToSend, 1, 255), "WHISPER", nil, cmd2 )--Cut off any characters after the 255th so the mesage will send
			else
				--pr'no ctl'
				SendChatMessage(sub(msgToSend, 1, 255), "WHISPER", nil, cmd2 )--Cut off any characters after the 255th so the mesage will send
			end
			pr("Sending whisper to "..cmd2..".")
		end]]
	else
		pr'Unknown command. Accepted commands are: toggle, on, off, set, available, frequency, current, up, use, help.\nKey "/tr help" for usage information.'
	end
end


addon:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)


addon:RegisterEvent("ADDON_LOADED")